package wzorceproj.laczenie.dekorator;

public class SymulatorKaczek {
   public static void main(String[] args) {
      SymulatorKaczek symulator = new SymulatorKaczek();
      symulator.uruchom();
   }

   void uruchom() {
      Kwacząca krzyżówkaKaczka = new KwakLicznik(new KrzyżówkaKaczka());
      Kwacząca płaskonosKaczka = new KwakLicznik(new PłaskonosKaczka());
      Kwacząca wabikKaczka = new KwakLicznik(new WabikKaczka());
      Kwacząca gumowaKaczka = new KwakLicznik(new GumowaKaczka());
      Kwacząca gęśKaczka = new GęśAdapter(new Gęś());

      System.out.println("\nSymulator kaczek: z dekoratorem");

      uruchom(krzyżówkaKaczka);
      uruchom(płaskonosKaczka);
      uruchom(wabikKaczka);
      uruchom(gumowaKaczka);
      uruchom(gęśKaczka);

      System.out.println("Kaczki zakwakały w sumie " + 
                         KwakLicznik.pobierzLiczbęKwaknięć() + " razy.");
   }

   void uruchom(Kwacząca kaczka) {
      kaczka.kwacz();
   }
}
